
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java集合（2）：LinkedList / 憋错料</title>

    <meta name="description" content="Java集合（2）：LinkedList 一.LinkedList介绍 LinkedList也和ArrayList一样实现了List接口,但是它执行插入和删除操作时比ArrayList更加高效,因为它是基于链表的.基于链表也决定了它在随机访问方面要比ArrayList逊色一点. 除此之外,LinkedList还提供了一些可以使其作为栈.队列.双端队列的方法.这些方法中有些彼此之间只是名称的区别,以使得这些名字在特定的上下文中显得更加的合适. 1.LinkedList的继承关系 public class LinkedList&lt;E&g ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java集合（2）：LinkedList</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h3>一.LinkedList介绍</h3>
<p>　　LinkedList也和ArrayList一样实现了List接口，但是它执行插入和删除操作时比ArrayList更加高效，因为它是基于链表的。基于链表也决定了它在随机访问方面要比ArrayList逊色一点。</p>
<p>　　除此之外，LinkedList还提供了一些可以使其作为栈、队列、双端队列的方法。这些方法中有些彼此之间只是名称的区别，以使得这些名字在特定的上下文中显得更加的合适。</p>
<h4>1.LinkedList的继承关系</h4>

<pre>public class LinkedList&lt;E&gt;
     extends AbstractSequentialList&lt;E&gt;
     implements List&lt;E&gt;, Deque&lt;E&gt;, Cloneable, java.io.Serializable
</pre>
<p>LinkedList的类图关系如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkyMjc2Mi8yMDE2MDcvOTIyNzYyLTIwMTYwNzE0MTU0MzM5NjA3LTE1MTIwNzk3NDUucG5n.jpg" />　　</p>
<ul>
<li>LinkedList 是一个继承于AbstractSequentialList的双向链表。它也可以被当作堆栈、队列或双端队列进行操作。</li>
<li>LinkedList 实现 List 接口，能对它进行队列操作。</li>
<li>LinkedList 实现 Deque 接口，即能将LinkedList当作双端队列使用。</li>
<li>LinkedList 实现了Cloneable接口，即覆盖了函数clone()，能克隆。</li>
<li>LinkedList 实现java.io.Serializable接口，这意味着LinkedList支持序列化，能通过序列化去传输。</li>
<li>LinkedList 是非同步的。</li>
</ul>
<h4>2.LinkedList数据结构原理</h4>
<p>LinkedList底层的数据结构是基于双向循环链表的，且头结点中不存放数据</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkyMjc2Mi8yMDE2MDcvOTIyNzYyLTIwMTYwNzE0MTU1MDAwNjg2LTE4MzAxNjA2NjMuanBn.jpg" /></p>
<h3>二.LinkedList源码解析</h3>
<h4>1.私有属性</h4>
<p>LinkedList中之定义了两个属性：</p>
<pre>private transient Entry&lt;E&gt; header = new Entry&lt;E&gt;(null, null, null);
private transient int size = 0;
</pre>
<p>　　header是双向链表的头节点，不包含数据，它是双向链表节点所对应的类Entry的实例。Entry中包含成员变量： previous, next, element。其中，previous是该节点的上一个节点，next是该节点的下一个节点，element是该节点所包含的值。 <br />　　size是双向链表中节点实例的个数。</p>
<h4>2.节点类即Entry类</h4>

<pre> 1 private static class Entry&lt;E&gt; {
 2     E element;
 3     Entry&lt;E&gt; next;
 4     Entry&lt;E&gt; previous;
 5
 6     Entry(E element, Entry&lt;E&gt; next, Entry&lt;E&gt; previous) {
 7         this.element = element;
 8         this.next = next;
 9         this.previous = previous;
10    }
11 }</pre>
<p>定义了存储的元素、前一个元素、后一个元素，这就是双向链表的节点的定义，每个节点只知道自己的前一个节点和后一个节点。</p>
<h4>3.LinkedList的构造方法</h4>

<pre>1 public LinkedList() {
2     header.next = header.previous = header;
3 }
4
5
6 public LinkedList(Collection&lt;? extends E&gt; c) {
7     this();
8    addAll(c);
9 }</pre>
<p>LinkedList提供了两个构造方法。</p>
<p>　　第一个构造方法不接受参数，将header实例的previous和next全部指向header实例（注意，这个是一个双向循环链表，如果不是循环链表，空链表的情况应该是header节点的前一节点和后一节点均为null），这样整个链表其实就只有header一个节点，用于表示一个空的链表。执行完构造函数后，header实例自身形成一个闭环。</p>
<p>　　第二个构造方法接收一个Collection参数c，调用第一个构造方法构造一个空的链表，之后通过addAll将c中的元素全部添加到链表中。</p>
<h4>4.元素添加</h4>

<pre> 1 // 将元素(E)添加到LinkedList中
 2      public boolean add(E e) {
 3          // 将节点(节点数据是e)添加到表头(header)之前。
 4          // 即，将节点添加到双向链表的末端。
 5          addBefore(e, header);
 6          return true;
 7      }
 8
 9      public void add(int index, E element) {
10          addBefore(element, (index==size ? header : entry(index)));
11      }
12
13     private Entry&lt;E&gt; addBefore(E e, Entry&lt;E&gt; entry) {
14          Entry&lt;E&gt; newEntry = new Entry&lt;E&gt;(e, entry, entry.previous);
15          newEntry.previous.next = newEntry;
16          newEntry.next.previous = newEntry;
17          size++;
18          modCount++;
19          return newEntry;
20     }</pre>
<p>　　addBefore(E e,Entry&lt;E&gt; entry)方法是个私有方法，所以无法在外部程序中调用（当然，这是一般情况，你可以通过反射上面的还是能调用到的）。</p>
<p>　　addBefore(E e,Entry&lt;E&gt; entry)先通过Entry的构造方法创建e的节点newEntry（包含了将其下一个节点设置为entry，上一个节点设置为entry.previous的操作，相当于修改newEntry的&ldquo;指针&rdquo;），之后修改插入位置后newEntry的前一节点的next引用和后一节点的previous引用，使链表节点间的引用关系保持正确。之后修改和size大小和记录modCount，然后返回新插入的节点。</p>
<p>　　总结，addBefore(E e,Entry&lt;E&gt; entry)实现在entry之前插入由e构造的新节点。而add(E e)实现在header节点之前插入由e构造的新节点。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkyMjc2Mi8yMDE2MDcvOTIyNzYyLTIwMTYwNzE0MTYyNTI1MjY0LTE4ODQwMDgxNDIuanBn.jpg" /></p>
<p>另外，还有addFirst和addLast方法</p>
<pre>1 public void addFirst(E e) {
2      addBefore(e, header.next);
3  }
4
5  public void addLast(E e) {
6      addBefore(e, header);
7  }</pre>
<p>　　addFrist(E e)只需实现在header元素的下一个元素之前插入，即示意图中的一号之前。addLast(E e)只需在实现在header节点前（因为是循环链表，所以header的前一个节点就是链表的最后一个节点）插入节点（插入后在2号节点之后）。</p>
<h4>5.删除数据remove()</h4>
<p>　　LinkedList中删除数据的方法有很多。remove()，remove(int index)，remove(Object o)，&nbsp;removeFirst()，removeLast()，removeFirstOccurrence()，removeLastOccurence()等。几个remove方法最终都是调用了一个私有方法：remove(Entry&lt;E&gt; e)，只是其他简单逻辑上的区别。下面分析remove(Entry&lt;E&gt; e)方法。</p>
<pre> 1 private E remove(Entry&lt;E&gt; e) {
 2     if (e == header)
 3         throw new NoSuchElementException();
 4     // 保留将被移除的节点e的内容
 5     E result = e.element;
 6     // 将前一节点的next引用赋值为e的下一节点
 7     e.previous.next = e.next;
 8     // 将e的下一节点的previous赋值为e的上一节点
 9     e.next.previous = e.previous;
10     // 上面两条语句的执行已经导致了无法在链表中访问到e节点，而下面解除了e节点对前后节点的引用
11     e.next = e.previous = null;
12     // 将被移除的节点的内容设为null
13     e.element = null;
14     // 修改size大小
15     size--;
16     modCount++;
17     // 返回移除节点e的内容
18     return result;
19 }</pre>
<p>清空预删除节点：</p>
<p>e.next = e.previous = null;</p>
<p>e.element = null;</p>
<p>交给gc完成资源回收，删除操作结束。</p>
<p>与ArrayList比较而言，LinkedList的删除动作不需要&ldquo;移动&rdquo;很多数据，从而效率更高。</p>
<h4>6.clear()和clone()方法</h4>
<p>(1).clear()</p>
<pre> 1 public void clear() {
 2 Entry&lt;E&gt; e = header.next;
 3 // e可以理解为一个移动的&ldquo;指针&rdquo;，因为是循环链表，所以回到header的时候说明已经没有节点了
 4 while (e != header) {
 5     // 保留e的下一个节点的引用
 6         Entry&lt;E&gt; next = e.next;
 7         // 接触节点e对前后节点的引用
 8         e.next = e.previous = null;
 9         // 将节点e的内容置空
10         e.element = null;
11         // 将e移动到下一个节点
12         e = next;
13 }
14 // 将header构造成一个循环链表，同构造方法构造一个空的LinkedList
15 header.next = header.previous = header;
16 // 修改size
17     size = 0;
18     modCount++;
19 }</pre>
<p>(2).clone()</p>
<pre> 1 public Object clone() {
 2     LinkedList&lt;E&gt; clone = null;
 3     try {
 4         clone = (LinkedList&lt;E&gt;) super.clone();
 5     } catch (CloneNotSupportedException e) {
 6         throw new InternalError();
 7    }
 8     clone.header = new Entry&lt;E&gt;(null, null, null);
 9     clone.header.next = clone.header.previous = clone.header;
10     clone.size = 0;
11     clone.modCount = 0;
12     for (Entry&lt;E&gt; e = header.next; e != header; e = e.next)
13        clone.add(e.element);
14     return clone;
15 }</pre>
<p>　　调用父类的clone()方法初始化对象链表clone，将clone构造成一个空的双向循环链表，之后将header的下一个节点开始将逐个节点添加到clone中。最后返回克隆的clone对象。</p>
<h4>7.toArray()方法</h4>
<p>(1).toArray()</p>
<pre>1 public Object[] toArray() {
2     Object[] result = new Object[size];
3     int i = 0;
4     for (Entry&lt;E&gt; e = header.next; e != header; e = e.next)
5         result[i++] = e.element;
6     return result;
7 }</pre>
<p>创建大小和LinkedList相等的数组result，遍历链表，将每个节点的元素element复制到数组中，返回数组。</p>
<p>(2).toArray(T[] a)</p>
<pre> 1 public &lt;T&gt; T[] toArray(T[] a) {
 2     if (a.length &lt; size)
 3         a = (T[])java.lang.reflect.Array.newInstance(
 4                                a.getClass().getComponentType(), size);
 5     int i = 0;
 6     Object[] result = a;
 7     for (Entry&lt;E&gt; e = header.next; e != header; e = e.next)
 8         result[i++] = e.element;
 9     if (a.length &gt; size)
10         a[size] = null;
11     return a;
12 }</pre>
<p>　　先判断出入的数组a的大小是否足够，若大小不够则拓展。这里用到了发射的方法，重新实例化了一个大小为size的数组。之后将数组a赋值给数组result，遍历链表向result中添加的元素。最后判断数组a的长度是否大于size，若大于则将size位置的内容设置为null。返回a。</p>
<p>　　从代码中可以看出，数组a的length小于等于size时，a中所有元素被覆盖，被拓展来的空间存储的内容都是null；若数组a的length的length大于size，则0至size-1位置的内容被覆盖，size位置的元素被设置为null，size之后的元素不变。</p>
<h4>8.遍历数据：Iterator()</h4>
<p>除了Entry，LinkedList还有一个内部类：ListItr。</p>
<p>ListItr实现了ListIterator接口，可知它是一个迭代器，通过它可以遍历修改LinkedList。</p>
<p>在LinkedList中提供了获取ListItr对象的方法：listIterator(int index)。</p>
<p>下面详细分析ListItr。</p>
<pre>  1 private class ListItr implements ListIterator&lt;E&gt; {
  2 // 最近一次返回的节点，也是当前持有的节点
  3     private Entry&lt;E&gt; lastReturned = header;
  4     // 对下一个元素的引用
  5     private Entry&lt;E&gt; next;
  6     // 下一个节点的index
  7     private int nextIndex;
  8     private int expectedModCount = modCount;
  9     // 构造方法，接收一个index参数，返回一个ListItr对象
 10     ListItr(int index) {
 11         // 如果index小于0或大于size，抛出IndexOutOfBoundsException异常
 12         if (index &lt; 0 || index &gt; size)
 13         throw new IndexOutOfBoundsException("Index: "+index+
 14                             ", Size: "+size);
 15         // 判断遍历方向
 16         if (index &lt; (size &gt;&gt; 1)) {
 17         // next赋值为第一个节点
 18         next = header.next;
 19         // 获取指定位置的节点
 20         for (nextIndex=0; nextIndex&lt;index; nextIndex++)
 21             next = next.next;
 22         } else {
 23 // else中的处理和if块中的处理一致，只是遍历方向不同
 24         next = header;
 25         for (nextIndex=size; nextIndex&gt;index; nextIndex--)
 26             next = next.previous;
 27        }
 28    }
 29     // 根据nextIndex是否等于size判断时候还有下一个节点（也可以理解为是否遍历完了LinkedList）
 30     public boolean hasNext() {
 31         return nextIndex != size;
 32    }
 33     // 获取下一个元素
 34     public E next() {
 35        checkForComodification();
 36         // 如果nextIndex==size,则已经遍历完链表，即没有下一个节点了（实际上是有的，因为是循环链表，任何一个节点都会有上一个和下一个节点，这里的没有下一个节点只是说所有节点都已经遍历完了）
 37         if (nextIndex == size)
 38         throw new NoSuchElementException();
 39         // 设置最近一次返回的节点为next节点
 40         lastReturned = next;
 41         // 将next&ldquo;向后移动一位&rdquo;
 42         next = next.next;
 43         // index计数加1
 44         nextIndex++;
 45         // 返回lastReturned的元素
 46         return lastReturned.element;
 47    }
 48
 49     public boolean hasPrevious() {
 50         return nextIndex != 0;
 51    }
 52     // 返回上一个节点，和next()方法相似
 53     public E previous() {
 54         if (nextIndex == 0)
 55         throw new NoSuchElementException();
 56
 57         lastReturned = next = next.previous;
 58         nextIndex--;
 59        checkForComodification();
 60         return lastReturned.element;
 61    }
 62
 63     public int nextIndex() {
 64         return nextIndex;
 65    }
 66
 67     public int previousIndex() {
 68         return nextIndex-1;
 69    }
 70     // 移除当前Iterator持有的节点
 71     public void remove() {
 72            checkForComodification();
 73             Entry&lt;E&gt; lastNext = lastReturned.next;
 74             try {
 75                 LinkedList.this.remove(lastReturned);
 76             } catch (NoSuchElementException e) {
 77                 throw new IllegalStateException();
 78            }
 79         if (next==lastReturned)
 80                 next = lastNext;
 81             else
 82         nextIndex--;
 83         lastReturned = header;
 84         expectedModCount++;
 85    }
 86     // 修改当前节点的内容
 87     public void set(E e) {
 88         if (lastReturned == header)
 89         throw new IllegalStateException();
 90        checkForComodification();
 91         lastReturned.element = e;
 92    }
 93     // 在当前持有节点后面插入新节点
 94     public void add(E e) {
 95        checkForComodification();
 96         // 将最近一次返回节点修改为header
 97         lastReturned = header;
 98        addBefore(e, next);
 99         nextIndex++;
100         expectedModCount++;
101    }
102     // 判断expectedModCount和modCount是否一致，以确保通过ListItr的修改操作正确的反映在LinkedList中
103     final void checkForComodification() {
104         if (modCount != expectedModCount)
105         throw new ConcurrentModificationException();
106    }
107 }</pre>
<p>下面是一个ListItr的使用实例。</p>
<pre> 1 LinkedList&lt;String&gt; list = new LinkedList&lt;String&gt;();
 2         list.add("First");
 3         list.add("Second");
 4         list.add("Thrid");
 5        System.out.println(list);
 6         ListIterator&lt;String&gt; itr = list.listIterator();
 7         while (itr.hasNext()) {
 8            System.out.println(itr.next());
 9        }
10         try {
11             System.out.println(itr.next());// throw Exception
12         } catch (Exception e) {
13             // TODO: handle exception
14        }
15         itr = list.listIterator();
16        System.out.println(list);
17        System.out.println(itr.next());
18         itr.add("new node1");
19        System.out.println(list);
20         itr.add("new node2");
21        System.out.println(list);
22        System.out.println(itr.next());
23         itr.set("modify node");
24        System.out.println(list);
25        itr.remove();
26         System.out.println(list);</pre>
<pre> 1 结果：
 2 [First, Second, Thrid]
 3 First
 4 Second
 5 Thrid
 6 [First, Second, Thrid]
 7 First
 8 [First, new node1, Second, Thrid]
 9 [First, new node1, new node2, Second, Thrid]
10 Second
11 [First, new node1, new node2, modify node, Thrid]
12 [First, new node1, new node2, Thrid]</pre>
<p>LinkedList还有一个提供Iterator的方法：descendingIterator()。该方法返回一个DescendingIterator对象。DescendingIterator是LinkedList的一个内部类。</p>
<h4>9.其他方法</h4>
<p>LinkedList中还有许多其他方法，在此不一一介绍。</p>
<p>contains(Object o)，element()，getFirst()，get(int index)，getLast()，set(int index,E element)，&nbsp;lastIndexOf(Object o)，</p>
<p>offer(E e) &nbsp;在链表尾部插入元素，offerFirst(E e) &nbsp;在链表开头插入元素，offerLast(E e) &nbsp;在链表末尾插入元素 &nbsp; &nbsp;这三个方法都调用了相应的add方法。</p>
<p>peek()，peekFirst()，peekLast() &nbsp;调用了对应的get方法</p>
<p>poll()，pollFirst()，pollLast() &nbsp;poll相关的方法都是获取并移除某个元素。都是和remove操作相关。</p>
<p>pop()，push(E e) &nbsp;弹出一个元素和压入一个元素，仅仅是调用了removeFirst()和addFirst()方法。</p>
<p>参考：<a href="http://www.cnblogs.com/ITtangtang/p/3948610.html#a9" rel="external nofollow noreferrer">http://www.cnblogs.com/ITtangtang/p/3948610.html#a9</a></p>
<p><a href="http://www.cnblogs.com/hzmark/archive/2012/12/25/LinkedList.html" rel="external nofollow noreferrer">http://www.cnblogs.com/hzmark/archive/2012/12/25/LinkedList.html</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-31 05:05:53 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java集合（2）：LinkedList的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wL9Yl4.html" rel="bookmark">死磕 java集合之LinkedList源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题 (1)LinkedList只是一个List吗? (2)LinkedList还有其它什么特性吗? (3)LinkedList为啥经常拿出来跟ArrayList比较? (4)我为什么把LinkedList放在最后一章来讲? 简介 LinkedList是一个以双向链表实现的List,它除了作为List使用,还可以作为队列或者栈来使用,它是怎么实现的呢?让我们一起来学习吧. 继承体系 通过继承体系,我们可以看到LinkedList不仅实现了List接口,还实现了Queue和Deque接口,所以它既			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xvRmN4.html" rel="bookmark">java集合－LinkedList</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LinkedList概念与简单实例 LinkedList类是双向列表,列表中的每个节点都包含了对前一个和后一个元素的引用. 1:LinkedList提供了4个不同位置的添加数据的方法,分别为链头插入,链尾插入,节点前插入,节点后插入 2:由于LinkedList是双向链表,在查询数据方面提供了&quot;从前往后&quot;和&quot;从后往前&quot;两个查询方法 3:如果数据量大,删除频繁,只能用LinkedList. 特别注意: list.get(i),LinkedList的底层是一个链表,随机			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/w3vZR63.html" rel="bookmark">Java集合类库 LinkedList 源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于JDK 1.7,和ArrayList进行比较分析 Java已经有了ArrayList,用来存放元素,对元素的操作都很方便.为什么还会有LinkedList呢?我们都知道ArrayList获取元素很快,但是插入一个元素很慢,因为ArrayList底层维护的是一个数组,往数组中的某个位置插入一个元素,是很消耗资源的. 而LinkedList插入元素很快,获取任意位置的元素却很慢.这是为什么呢?底层又是怎样实现的呢? 1.继承关系 LinkedList的继承关系图: LinkedList继承的是A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/w3vBAR3.html" rel="bookmark">Java 集合之LinkedList源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.介绍 链表是数据结构中一种很重要的数据结构,一个链表含有一个或者多个节点,每个节点处理保存自己的信息之外还需要保存上一个节点以及下一个节点的指针信息.通过链表的表头就可以访问整个链表的信息.Java API中提供了链表的Java实现---LinkedList下.LinkedList是通过节点的连接实现链表的数据结构,向linkedList中插入或删除元素的速度是特别快,而随机访问的速度相对较慢,这个是由于链表本身的性质造成的,在链表中,每个节点都包含了前一个节点的引用,后一个节点的引用和节点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wv8KV0.html" rel="bookmark">【JAVA集合】LinkedList</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下内容基于jdk1.7.0_79源码: 什么是LinkedList List接口的链表实现,并提供了一些队列,栈,双端队列操作的方法: LinkedList补充说明 与ArrayList对比,LinkedList插入和删除操作更加高效,随机访问速度慢: 可以作为栈.队列.双端队列数据结构使用: 非同步,线程不安全: 与ArrayList.Vector一样,LinkedList的内部迭代器存在“快速失败行为”: 支持null元素.有顺序.元素可以重复: LinkedList继承的类以及实现的接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O7NQo3.html" rel="bookmark">从源码分析java集合【LinkedList】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LinkedList是一个双端链表,他继承了AbstractSequentaiList顺序列表,实现了List,Deque,Cloneable,和Serializable接口.Deque是双端队列的接口,LinkedList有记录头的 first 和 尾的 last,所以我们可以对队列的两端进行操作.它还实现了Cloneable和Serializeble接口,它们分别是实现队列进行拷贝和序列化的接口. LinkedList的节点的结构是: private static class Node&lt;E&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyDz6a4.html" rel="bookmark">java集合之LinkedList</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LinkedList:位于java.util包下 1 LinkedList概述 特点:底层数据结构是链表,增删快查询慢:实现非同步,线程不安全,效率高:有序(存取顺序一致):允许存储重复值:允许存储null值:易于实现堆栈.队列.双向队列结构: 常用构造: public LinkedList(): 空参构造,构建一个空列表. 常用方法:和ArrayList差不多,此处仅列出特有的功能方法. 1)添加功能: public addFirst(E e) :将指定元素插入此列表的开头. public a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41arAP4.html" rel="bookmark">Java集合四LinkedList</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LinkedList简介 继承于AbstractSequentialList的双向链表,可以被当做堆栈.队列或双端队列进行操作. LinkedList本质上是一个双向链表,实现了Dequeue接口. LinkedList包含两个重要的成员:header和size. header是双向链表的表头,它是双向链表节点所对应的类Node的实例.Node中包含成员变量:prev.next.item.其中prev是该节点的上一个节点,next是该节点的下一个节点,item是该节点所包含的值. private			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QZObkM.html" rel="bookmark">Java集合之LinkedList常见实例操作，实例说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.LinkedList常见操作 package List相关; /** * LinkedList 链接列表 * LinkedList:底层使用的链表数据结构.特点:增删速度快,查询速度稍慢: */ import java.util.Iterator; import java.util.LinkedList; class linkedlist_test { public static void main(String[] args){ LinkedList linkedlist = new Li			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBkjAJ0.html" rel="bookmark">【Java集合】-- LinkedList源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 继承体系 数据结构 源码解析 1.属性 2.构造方法 LinkedList() LinkedList(Collection&lt;? extends E&gt; c) 3.添加元素 add(E e) addFirst(E e) addLast(E e) add(int index, E element) offer(E e) offerFirst(E e) offerLast(E e) 总结 4.获取元素 get(int index) getFirst() getLast() peek() 5.删除			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMP8A1M.html" rel="bookmark" class="title">python运维开发&lpar;二十&rpar;----models操作、中间件、缓存、信号、分页</a>
					<div>
						内容目录 select Form标签数据库操作 models操作F/Q models多对多表操作 Django中间件 缓存 信号 分页 select Form标签补充 在上一节中我们可以知道Form标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rpe1M.html" rel="bookmark" class="title">asp&period;net core MVC 全局过滤器之ExceptionFilter过滤器&lpar;一&rpar;</a>
					<div>
						本系类将会讲解asp.net core MVC中的内置全局过滤器的使用,将分为以下章节 asp.net core MVC 过滤器之ExceptionFilter过滤器(一) asp.net core  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n1EgPM.html" rel="bookmark" class="title">2-3</a>
					<div>
						为方便旅客,某航空公司拟开发一个机票预定系统.旅行社把预定机票的旅客信息(姓名.性别.工作单位.身份证号码.旅行时间.旅行目的地等)输入进入该系统,系统为旅客安排航班,印出取票通知和账单,旅客在飞机起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wvZKj0.html" rel="bookmark" class="title">HDU2836 Traversal</a>
					<div>
						题解: dp+树状数组优化 跟hdu2227差不多,只不过改变了一下范围.更改一下sum的方式即可 但是这题的a[i]范围比较大. 在用树状数组时,一种是直接使用map,另一种是使用hash+二分 代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MB17VJ4.html" rel="bookmark" class="title">HDU 4897 Little Devil I</a>
					<div>
						_(:3 ⌒?)_ 调我半天,还是记录下吧. 用轻重链可解决此题. 用轻重链的方式给点重新编号后,建两棵线段树,一棵(sumTree)用于记录路径修改,另外一棵(markTree)用于记录邻边修改的点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8GbyM.html" rel="bookmark" class="title">Spring随笔（06）</a>
					<div>
						1.简单类型和复合类型的setter注入 DI:Dependency Injection(依赖注入) 从字面上分析: IoC:指将对象的创建权,反转到Spring容器 DI:指Spring容器创建对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz12OJ4.html" rel="bookmark" class="title">NSUserDefaults的简单使用</a>
					<div>
						运行结果:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZOZ73.html" rel="bookmark" class="title">Build path contains duplicate entry&colon;&amp;&num;39&semi;lib&sol;xxxxxxx&period;jar&amp;&num;39&semi; for project &amp;&num;39&semi;xxxxxx&amp;&num;39&semi;</a>
					<div>
						eclipse在编译时出现的问题: 问题描述:因为jar包路劲重复所造成的问题: Probleams View: Errors: Build path contains duplicate entry ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QwQKw0.html" rel="bookmark" class="title">JavaScript发布&sol;订阅实例</a>
					<div>
						原文链接: Pub/Sub JavaScript Object原文日期: 2014年6月11日翻译日期: 2014年6月13日 翻译人员: 铁锚 高效AJAX网站的三大杀器: 事件代理, 浏览历史管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47wm1o4.html" rel="bookmark" class="title">内存映射（Linux设备驱动程序）</a>
					<div>
						第一部分:mmap系统调用直接将设备内存映射到用户进程的地址空间里. 第二部分:跨越边界直接訪问用户空间的内存页.一些相关的驱动程序须要这样的能力,(用户空间内存怎样映射到内核中的方法get_user ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGRV7V4.html" rel="bookmark" class="title">c&num;  &quest;和&quest;&quest; 用法</a>
					<div>
						本文不讨论:条件(三元)运算符 (?:) 本文假定你熟悉值类型.引用类型.可空化.泛型等基本概念 概念 ?:可空类修饰符,是System.Nullable&lt;T&gt;的简写,下面两条语句等效.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47wvn64.html" rel="bookmark" class="title">prolog第一个程序</a>
					<div>
						PREDICATES student(integer,string,real) gradeGOAL grade.CLAUSES student(1,&quot;张三&quot;,90.2). stud ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLv2XQ3.html" rel="bookmark" class="title">Oracle分析函数学习总结</a>
					<div>
						在公司经常会用到oracle分析函数,在统计这块用处很大,特别是复杂的sql查询,我就在这边结合网络一些资料进行了总结,希望可以帮助到大家: Oracle分析函数--函数列表 SUM          ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Kvo6wM.html" rel="bookmark" class="title">Java标签实现分页</a>
					<div>
						Java实现标签分页 最近为了开发一个网站,里面要用分页功能,但是之前很少自己写分页标签,又不想用现成框架.所以自己参考了些资料,写了个分页例子测试了一下. 代码主要分为三个类: PageTag 分页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/351lJE3.html" rel="bookmark" class="title">数字运算符和函数</a>
					<div>
						ceil 向上取整/进一取整 mysql&gt; select ceil(3.01); +------------+ | ceil(3.01) | +------------+ | 4 | +---- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wOXG0.html" rel="bookmark" class="title">上传多张图片用Session临时存储</a>
					<div>
						DataTable dtImages = new DataTable(); string filepath = FileUpload1.PostedFile.FileName; //检查是否有文件要上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AxdD53.html" rel="bookmark" class="title">Imread函数不好使的替用方法</a>
					<div>
						Mat img = imread(&quot;pp.jpg&quot;); || IplImage*iplImg = cvLoadImage(&quot;pp.jpg&quot;);//由于imrea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQDGn3.html" rel="bookmark" class="title">MongoDB文档的增删改操作</a>
					<div>
						上一篇文章中介绍了MongoDB的一些基本知识,同时看到了怎么启动一个MongoDB服务,并且通过MongoDB自带的shell工具连接到了服务器. 这一次,就通过MongoDB shell介绍一下对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RQVxjM.html" rel="bookmark" class="title">hdu 1134 Game of Connections 【卡特兰数&plus;大数】</a>
					<div>
						Game of Connections Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Othe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ealBp0.html" rel="bookmark" class="title">时间字段的类型用时间戳整型还是时间类型</a>
					<div>
						不管做什么项目,必须都得接触的东西就是时间类型.现在用时间戳存储日期数据(整型存储)已经是业界很平常的的事情,网上各大游戏公司,各大开源都是采取整型时间戳存储.整数存日期好处很多,程序判断直读,扩展性 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
